package falkor;

import java.awt.AWTEvent;
import java.awt.Canvas;
import java.util.concurrent.LinkedBlockingQueue;

import falkor.ui.InputThread;
import falkor.ui.MainWindow;
import falkore.core.GameState;
import falkore.core.RenderThread;
import falkore.core.StateThread;

public class Launcher {
   public static int BUFFER_COUNT = 2;
   public static void main(String[] args) {
      LinkedBlockingQueue<AWTEvent> eventQueue = 
            new LinkedBlockingQueue<AWTEvent>();

      GameState gameState = 
            new GameState();
      Canvas drawCanvas = 
            new Canvas();
      MainWindow interfaceInstance = 
            new MainWindow(drawCanvas, eventQueue);
      RenderThread renderThread =
            new RenderThread(gameState, drawCanvas );
      StateThread gameThread =
            new StateThread(gameState);
      InputThread inputThread =
            new InputThread(eventQueue, gameState, drawCanvas);

      interfaceInstance.setVisible(true);
      drawCanvas.createBufferStrategy(BUFFER_COUNT);
      drawCanvas.requestFocus();

      gameThread.start();
      renderThread.start();
      inputThread.start();

      try {
         renderThread.join();
         gameThread.join();
         inputThread.join();
      } catch (InterruptedException ie) {
         System.err.println(
               "warning: synch error on shutdown: " + ie + " : " +
                     renderThread.getState() + " " +
                     gameThread.getState() + " " +
                     inputThread.getState()
               );
      }

      interfaceInstance.setVisible(false);
      System.exit(0);
   }
}
